From 76b462461bf63f4cfdfae695792ebb962d6d5d61 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Oct 02 2017 15:27:34 +0000
Subject: [PATCH 963/1001] Add the new and reworked React UI


---

diff --git a/hubs/static/client/.babelrc b/hubs/static/client/.babelrc
index 25043d0..aa30d85 100644
--- a/hubs/static/client/.babelrc
+++ b/hubs/static/client/.babelrc
@@ -1,5 +1,10 @@
 {
-  "presets" : ["es2015", "react"],
-  "plugins": ["syntax-dynamic-import"]
+  "presets" : [["es2015", {"modules": false}], "react"],
+  "plugins": ["syntax-dynamic-import", "transform-object-rest-spread"],
+  "env": {
+    "test": {
+      "plugins": ["transform-es2015-modules-commonjs", "dynamic-import-node", "transform-object-rest-spread"]
+    }
+  }
 }
 
diff --git a/hubs/static/client/__mocks__/fileMock.js b/hubs/static/client/__mocks__/fileMock.js
new file mode 100644
index 0000000..7275f13
--- /dev/null
+++ b/hubs/static/client/__mocks__/fileMock.js
@@ -0,0 +1,2 @@
+// http://facebook.github.io/jest/docs/en/webpack.html
+module.exports = 'test-file-stub';
diff --git a/hubs/static/client/__mocks__/styleMock.js b/hubs/static/client/__mocks__/styleMock.js
new file mode 100644
index 0000000..6a99daa
--- /dev/null
+++ b/hubs/static/client/__mocks__/styleMock.js
@@ -0,0 +1,2 @@
+// http://facebook.github.io/jest/docs/en/webpack.html
+module.exports = {};
diff --git a/hubs/static/client/app/components/AddWidget/AddWidgetDialog.js b/hubs/static/client/app/components/AddWidget/AddWidgetDialog.js
new file mode 100644
index 0000000..2d48f90
--- /dev/null
+++ b/hubs/static/client/app/components/AddWidget/AddWidgetDialog.js
@@ -0,0 +1,198 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import SimpleWidgetConfig from '../SimpleWidgetConfig';
+import WidgetSelectDialog from './WidgetSelectDialog';
+import Modal from '../Modal';
+import { getAvailableWidgets } from '../../core/actions/widgets';
+import { addWidget } from '../../core/actions/widget';
+import {
+  makeLoadable,
+  makeLoadingComponent
+} from '../../core/utils';
+
+
+class AddWidgetDialog extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      selectedWidget: null,
+      tempSelectedWidget: null, // only track the select dropdown state
+      widgetConfig: {visibility: "public"},
+    };
+    this.handleSelectClicked = this.handleSelectClicked.bind(this);
+    this.handleAddClicked = this.handleAddClicked.bind(this);
+    this.handleWidgetSelectChanged = this.handleWidgetSelectChanged.bind(this);
+    this.setWidgetConfig = this.setWidgetConfig.bind(this);
+  }
+
+  componentDidMount() {
+    this.props.dispatch(getAvailableWidgets());
+  }
+
+  componentDidUpdate(prevProps, prevState) {
+    // Select the first available widget by default.
+    const widgets = this.props.availableWidgets[this.props.position];
+    if (widgets.length > 0 && !this.state.tempSelectedWidget) {
+      this.setState({tempSelectedWidget: widgets[0]});
+    }
+  }
+
+  handleWidgetSelectChanged(e) {
+    this.setState({tempSelectedWidget: e.target.value});
+  }
+
+  setWidgetConfig(name, value) {
+    this.setState((prevState, props) => {
+      prevState.widgetConfig[name] = value;
+      return {widgetConfig: prevState.widgetConfig};
+    });
+  }
+
+  handleSelectClicked(e) {
+    e.preventDefault();
+    this.setState((prevState, props) => {
+      let selectedName = prevState.tempSelectedWidget,
+          selectedWidget = this.props.availableWidgets.byName[selectedName],
+          widgetConfig = {};
+      selectedWidget.params.forEach((param) => {
+        widgetConfig[param.name] = param.default;
+      });
+      return { selectedWidget, widgetConfig };
+    });
+  }
+
+  handleAddClicked(e) {
+    e.preventDefault();
+    this.props.dispatch(addWidget(
+      this.state.selectedWidget.name,
+      this.state.widgetConfig,
+      this.props.position)
+    );
+    this.props.handleDialogCloseClicked(e);
+  }
+
+  render() {
+    const widgets = this.props.availableWidgets[this.props.position].map(
+      (name) => (this.props.availableWidgets.byName[name])
+    );
+    let title = "Add a new widget",
+        contents, submitButton;
+
+    if (this.props.isLoading) {
+      contents = (
+        <p className="text-muted">Loading...</p>
+        );
+      submitButton = (
+        <button
+          type="button"
+          className="btn btn-primary"
+          disabled={true}
+          >
+          Loading...
+        </button>
+      );
+
+    } else if (this.state.selectedWidget === null) {
+      // First step: select the widget
+      contents = (
+        <WidgetSelectDialog
+          availableWidgets={widgets}
+          handleWidgetSelectChanged={this.handleWidgetSelectChanged}
+          selectedWidgetName={this.state.tempSelectedWidget}
+          selectedVisibility={this.state.widgetConfig.visibility}
+          setConfig={this.setWidgetConfig}
+          showVisibilitySelect={this.props.showVisibilitySelect}
+          />
+      );
+      submitButton = (
+        <button
+          type="button"
+          className="btn btn-primary ml-3"
+          onClick={this.handleSelectClicked}
+          >
+          Select widget
+        </button>
+      );
+
+    } else {
+      // Second step: configure the widget
+      title = "Adding widget " + this.state.selectedWidget.label;
+      if (this.state.selectedWidget.isReact) {
+        const AsyncComponent = makeLoadable(
+          () => import(`../../widgets/${this.state.selectedWidget.name}/Config`),
+          makeLoadingComponent(
+            "Loading widget configuration...",
+            "Sorry, there was a problem loading the widget configuration."
+          )
+        );
+        contents = (
+          <AsyncComponent
+            widget={this.state.selectedWidget}
+            values={this.state.widgetConfig}
+            setConfig={this.setWidgetConfig}
+            />
+        );
+      } else {
+        contents = (
+          <SimpleWidgetConfig
+            widget={this.state.selectedWidget}
+            values={this.state.widgetConfig}
+            setConfig={this.setWidgetConfig}
+            />
+        );
+      }
+      submitButton = (
+        <button
+          type="button"
+          className="btn btn-primary ml-3"
+          onClick={this.handleAddClicked}
+          >
+          Add widget
+        </button>
+      );
+    }
+
+    const footer = (
+      <div className="d-flex justify-content-end w-100">
+        <button
+          type="button"
+          className="btn btn-secondary"
+          onClick={this.props.handleDialogCloseClicked}
+          >
+          Close
+        </button>
+        {submitButton}
+      </div>
+    );
+
+    return (
+      <Modal
+        onCloseClicked={this.props.handleDialogCloseClicked}
+        isLarge={this.state.selectedWidget && this.state.selectedWidget.isReact}
+        title={title}
+        footer={footer}
+        >
+        {contents}
+      </Modal>
+    );
+  }
+}
+AddWidgetDialog.propTypes = {
+  position: PropTypes.string.isRequired,
+  handleDialogCloseClicked: PropTypes.func,
+}
+
+
+const mapStateToProps = (state) => {
+  return {
+    availableWidgets: state.entities.availableWidgets,
+    isLoading: state.entities.availableWidgets.isLoading,
+    showVisibilitySelect: (
+      state.entities.hub.config.visibility === "preview"
+    ),
+  }
+};
+
+export default connect(mapStateToProps)(AddWidgetDialog);
diff --git a/hubs/static/client/app/components/AddWidget/WidgetSelectDialog.js b/hubs/static/client/app/components/AddWidget/WidgetSelectDialog.js
new file mode 100644
index 0000000..9577e71
--- /dev/null
+++ b/hubs/static/client/app/components/AddWidget/WidgetSelectDialog.js
@@ -0,0 +1,53 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import VisibilitySelect from '../VisibilitySelect';
+
+
+export default class WidgetSelectDialog extends React.Component {
+
+  propTypes: {
+    availableWidgets: PropTypes.array.isRequired,
+    showVisibilitySelect: PropTypes.bool,
+    handleWidgetSelectChanged: PropTypes.func.isRequired,
+    selectedWidgetName: PropTypes.string.isRequired,
+    selectedVisibility: PropTypes.string.isRequired,
+    setConfig: PropTypes.func.isRequired,
+  }
+
+  render() {
+    const options = this.props.availableWidgets.map((widget) => {
+      return (
+        <option
+          key={widget.name}
+          value={widget.name}
+          >
+          {widget.label}
+        </option>
+      );
+    });
+    return (
+      <div>
+        <fieldset className="form-group">
+          { this.props.showVisibilitySelect &&
+            <label htmlFor="widgetname">Widget name:</label>
+          }
+          <select
+            className="form-control"
+            name="widgetname"
+            onChange={this.props.handleWidgetSelectChanged}
+            value={this.props.selectedWidgetName || ""}
+            >
+            {options}
+          </select>
+        </fieldset>
+        { this.props.showVisibilitySelect &&
+          <VisibilitySelect
+            selectedVisibility={this.props.selectedVisibility}
+            setConfig={this.props.setConfig}
+            />
+        }
+      </div>
+    );
+  }
+}
diff --git a/hubs/static/client/app/components/AddWidget/index.js b/hubs/static/client/app/components/AddWidget/index.js
new file mode 100644
index 0000000..18c3455
--- /dev/null
+++ b/hubs/static/client/app/components/AddWidget/index.js
@@ -0,0 +1,75 @@
+import React from 'react';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import PropTypes from 'prop-types';
+import AddWidgetDialog from './AddWidgetDialog';
+
+
+const messages = defineMessages({
+  button: {
+    id: "hubs.core.widgets.add.button",
+    defaultMessage: "Add a widget",
+  },
+});
+
+
+class AddWidgetButton extends React.Component {
+
+  render() {
+    return (
+      <div className='widget row AddWidgetButton'>
+        <button
+          className="btn btn-lg btn-secondary w-100"
+          onClick={this.props.handleClicked}
+          >
+          <i className="fa fa-plus mr-2" aria-hidden="true"></i>
+          <FormattedMessage {...messages.button} />
+        </button>
+      </div>
+    );
+  }
+}
+
+
+export default class AddWidget extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      isDialogOpen: false,
+    };
+    this.handleOpenClicked = this.handleOpenClicked.bind(this);
+    this.handleCloseClicked = this.handleCloseClicked.bind(this);
+  }
+
+  handleOpenClicked(e) {
+    e.preventDefault();
+    this.setState({
+      isDialogOpen: true,
+    });
+  }
+
+  handleCloseClicked(e) {
+    if (e) { e.preventDefault(); }
+    this.setState({isDialogOpen: false});
+  }
+
+  render() {
+    return (
+      <div>
+        <AddWidgetButton
+          handleClicked={this.handleOpenClicked}
+          />
+        { this.state.isDialogOpen &&
+          <AddWidgetDialog
+            position={this.props.position}
+            handleDialogCloseClicked={this.handleCloseClicked}
+            />
+        }
+      </div>
+    );
+  }
+
+}
diff --git a/hubs/static/client/app/components/CobWeb/index.js b/hubs/static/client/app/components/CobWeb/index.js
new file mode 100644
index 0000000..65b807a
--- /dev/null
+++ b/hubs/static/client/app/components/CobWeb/index.js
@@ -0,0 +1,34 @@
+import React from 'react';
+import TimeAgo from 'react-timeago';
+//import './cobweb.css';
+import ArchivedIcon from './archived.png';
+import CobWebIcon from './cobweb.png';
+
+
+export default class CobWeb extends React.Component {
+
+  render() {
+    let icon = null, msg = null;
+    if (this.props.cause == "archived") {
+        icon = ArchivedIcon;
+        msg = "This hub has been archived and locked.";
+    } else {
+        icon = CobWebIcon;
+        msg = (
+            <span>
+                <span>Cobweb alert!  This hub was last active </span>
+                <TimeAgo date={this.props.mtime} />
+            </span>
+            );
+    }
+    return (
+      <div className="CobWeb media mb-3">
+        <img className="d-flex align-self-center mr-3 square-32" src={icon} />
+        <div className="media-body">
+          {msg}
+        </div>
+      </div>
+    );
+  }
+}
+
diff --git a/hubs/static/client/app/components/CompletionInput.js b/hubs/static/client/app/components/CompletionInput.js
new file mode 100644
index 0000000..a90cd07
--- /dev/null
+++ b/hubs/static/client/app/components/CompletionInput.js
@@ -0,0 +1,144 @@
+import React from 'react';
+import Autosuggest from 'react-autosuggest';
+import Spinner from "./Spinner";
+import "./CompletionInput.css";
+
+
+export default class CompletionInput extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      value: "",
+      suggestions: [],
+      isLoading: false
+    }
+    this.resultsDomNodeStyle = {
+      position: "absolute",
+      width: "auto"
+    }
+    this.queryTimeout = null;
+    this.handleChange = this.handleChange.bind(this);
+    this.handleSuggestionSelected = this.handleSuggestionSelected.bind(this);
+    this.handleSuggestionsFetchRequested = this.handleSuggestionsFetchRequested.bind(this);
+    this.handleSuggestionsClearRequested = this.handleSuggestionsClearRequested.bind(this);
+    this.loadFromServer = this.loadFromServer.bind(this);
+  }
+
+  componentWillUnmount() {
+    if (this.serverRequest) { this.serverRequest.abort(); }
+  }
+
+  handleChange(e, {newValue}) {
+    this.setState({
+      value: newValue
+    });
+    // Transmit a "fake" changed event to the parent, if asked to.
+    if (this.props.onChange) {
+      const mockedEvent = {
+        type: 'change',
+        target: {
+          type: 'input',
+          name: this.props.name || "completioninput",
+          value: newValue,
+        },
+      }
+      this.props.onChange(mockedEvent, newValue);
+    }
+  }
+
+  handleSuggestionSelected(e, {suggestion}) {
+    if (this.props.onSelect) {
+      this.props.onSelect(suggestion);
+    }
+  }
+
+  // Autosuggest will call this function every time you need to update
+  // suggestions.
+  handleSuggestionsFetchRequested({value}) {
+    var inputValue = value.trim().toLowerCase();
+    if (this.queryTimeout !== null) {
+      window.clearTimeout(this.queryTimeout);
+    }
+    if (this.serverRequest) { this.serverRequest.abort(); }
+    if (inputValue.length === 0) {
+      this.setState({
+        suggestions: [],
+        isLoading: false
+      });
+    } else {
+      this.queryTimeout = window.setTimeout(
+        this.loadFromServer, this.props.queryDelay, inputValue);
+    }
+  }
+
+  loadFromServer(value) {
+    this.setState({isLoading: true});
+    this.serverRequest = $.ajax({
+      url: this.props.url,
+      method: 'GET',
+      data: {q: value},
+      dataType: 'json',
+      cache: false,
+      success: function(result) {
+        var suggestions = result.data;
+        if (this.props.filterResults) {
+          suggestions = suggestions.filter(this.props.filterResults);
+        }
+        this.setState({suggestions: suggestions});
+      }.bind(this),
+      error: function(xhr, status, err) {
+        console.error(this.props.url, status, err.toString());
+      }.bind(this),
+      complete: function(xhr, status) {
+        this.setState({isLoading: false});
+      }.bind(this)
+    });
+  }
+
+  // Autosuggest will call this function every time you need to clear
+  // suggestions.
+  handleSuggestionsClearRequested() {
+    this.setState({
+      suggestions: []
+    });
+  }
+
+  render() {
+    // When a suggestion is clicked, this method will return the value to
+    // populate the input with.
+    const getSuggestionValue = (suggestion) => (suggestion);
+    // Render suggestions.
+    const renderSuggestion = (suggestion) => (suggestion);
+    // Autosuggest will pass through all these props to the input element.
+    const inputProps = {
+      className: "form-control",
+      value: this.state.value,
+      onChange: this.handleChange,
+    };
+    Object.assign(inputProps, this.props.inputProps);
+
+    // Render the widget.
+    return (
+      <div className="CompletionInput">
+        <Autosuggest
+          suggestions={this.state.suggestions}
+          onSuggestionsFetchRequested={this.handleSuggestionsFetchRequested}
+          onSuggestionsClearRequested={this.handleSuggestionsClearRequested}
+          onSuggestionSelected={this.handleSuggestionSelected}
+          getSuggestionValue={this.props.getSuggestionValue || getSuggestionValue}
+          renderSuggestion={this.props.renderSuggestion || renderSuggestion}
+          inputProps={inputProps}
+        />
+        {this.state.isLoading &&
+          <Spinner circle={true} />
+        }
+      </div>
+    );
+  }
+
+}
+CompletionInput.defaultProps = {
+    inputProps: {},
+    queryDelay: 800,
+};
diff --git a/hubs/static/client/app/components/EditModeButton.js b/hubs/static/client/app/components/EditModeButton.js
new file mode 100644
index 0000000..70eb64d
--- /dev/null
+++ b/hubs/static/client/app/components/EditModeButton.js
@@ -0,0 +1,74 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import { setEditMode } from "../core/actions/widgets";
+import "./EditModeButton.css";
+
+
+const messages = defineMessages({
+  save: {
+    id: "hubs.core.EditModeButton.save",
+    defaultMessage: "Save changes",
+  },
+  edit: {
+    id: "hubs.core.EditModeButton.edit",
+    defaultMessage: "Edit page layout",
+  },
+});
+
+
+class EditModeButton extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.handleClicked = this.handleClicked.bind(this);
+  }
+
+  handleClicked(e) {
+    e.preventDefault();
+    this.props.dispatch(setEditMode(!this.props.editMode));
+  }
+
+  render() {
+    if (this.props.editMode) {
+      return (
+        <button
+          className="EditModeButton btn btn-sm btn-primary"
+          onClick={this.handleClicked}
+          >
+          <i className="fa fa-download mr-2" aria-hidden="true"></i>
+          <FormattedMessage {...messages.save} />
+        </button>
+      );
+    } else {
+      return (
+        <button
+          className="EditModeButton btn btn-sm btn-secondary"
+          onClick={this.handleClicked}
+          >
+          <i className="fa fa-pencil mr-2" aria-hidden="true"></i>
+          <FormattedMessage {...messages.edit} />
+        </button>
+      );
+    }
+  }
+}
+EditModeButton.propTypes = {
+  editMode: PropTypes.bool,
+}
+EditModeButton.defaultProps = {
+  editMode: false
+}
+
+
+const mapStateToProps = (state) => {
+  return {
+    editMode: state.ui.widgetsEditMode
+  }
+};
+
+export default connect(mapStateToProps)(EditModeButton);
diff --git a/hubs/static/client/app/components/FlashMessages/FlashMessage.js b/hubs/static/client/app/components/FlashMessages/FlashMessage.js
new file mode 100644
index 0000000..02b903d
--- /dev/null
+++ b/hubs/static/client/app/components/FlashMessages/FlashMessage.js
@@ -0,0 +1,54 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+
+
+const MSG_TYPES = ["success", "info", "warning", "danger"];
+
+
+export default class FlashMessage extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.handleClose = this.handleClose.bind(this);
+  }
+
+  handleClose(e) {
+    this.props.onClose(this.props.index);
+  }
+
+  render() {
+    let cssClass = this.props.type;
+    if (cssClass === "error") {
+      cssClass = "danger";
+    }
+    if (!MSG_TYPES.includes(cssClass)) {
+      cssClass = "info";
+    }
+    return (
+      <div
+        className={`alert alert-dismissible alert-${cssClass}`}
+        role="alert"
+        >
+        <button
+          type="button"
+          className="close"
+          aria-label="Close"
+          name={this.props.index}
+          onClick={this.handleClose}
+          >
+          <span aria-hidden="true">&times;</span>
+        </button>
+        {this.props.message}
+      </div>
+    );
+  }
+}
+FlashMessage.propTypes = {
+  message: PropTypes.string.isRequired,
+  index: PropTypes.number.isRequired,
+  type: PropTypes.string,
+  onClose: PropTypes.func,
+}
+FlashMessage.defaultProps = {
+  type: "info",
+}
diff --git a/hubs/static/client/app/components/FlashMessages/FlashMessagesList.js b/hubs/static/client/app/components/FlashMessages/FlashMessagesList.js
new file mode 100644
index 0000000..851da6a
--- /dev/null
+++ b/hubs/static/client/app/components/FlashMessages/FlashMessagesList.js
@@ -0,0 +1,39 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import FlashMessage from './FlashMessage';
+import "./FlashMessages.css";
+
+
+export default class FlashMessagesList extends React.Component {
+
+  render() {
+    if (this.props.messages.length === 0) {
+      return null;
+    }
+    let messages = this.props.messages.map(({msg, type}, index) => {
+      return (
+        <FlashMessage
+          key={index}
+          message={msg}
+          type={type}
+          index={index}
+          onClose={this.props.onClose}
+          />
+      );
+    });
+    return (
+      <div className="FlashMessages row pt-2">
+        <div className="col-md-6 offset-md-3">
+          {messages}
+        </div>
+      </div>
+    );
+  }
+}
+FlashMessagesList.propTypes = {
+  messages: PropTypes.array,
+  onClose: PropTypes.func,
+}
+FlashMessagesList.defaultProps = {
+  messages: [],
+}
diff --git a/hubs/static/client/app/components/FlashMessages/index.js b/hubs/static/client/app/components/FlashMessages/index.js
new file mode 100644
index 0000000..278af61
--- /dev/null
+++ b/hubs/static/client/app/components/FlashMessages/index.js
@@ -0,0 +1,23 @@
+import { connect } from 'react-redux';
+import { closeFlashMessage } from '../../core/actions/flashMessages';
+import FlashMessagesList from "./FlashMessagesList";
+
+
+const mapStateToProps = (state) => {
+  return {
+    messages: state.flashMessages
+  }
+};
+
+const mapDispatchToProps = (dispatch) => {
+  return {
+    onClose: (id) => {
+      dispatch(closeFlashMessage(id))
+    }
+  }
+};
+
+export default connect(
+  mapStateToProps,
+  mapDispatchToProps
+)(FlashMessagesList);
diff --git a/hubs/static/client/app/components/HubConfig/HubConfigDialog.js b/hubs/static/client/app/components/HubConfig/HubConfigDialog.js
new file mode 100644
index 0000000..6d00e05
--- /dev/null
+++ b/hubs/static/client/app/components/HubConfig/HubConfigDialog.js
@@ -0,0 +1,129 @@
+import React from 'react';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import PropTypes from 'prop-types';
+import GeneralPanel from './HubConfigPanelGeneral';
+import UserPanel from './HubConfigPanelUser';
+import ChatPanel from './HubConfigPanelChat';
+import NotImplementedPanel from './HubConfigPanelNotImpl';
+import Modal from '../../components/Modal';
+import TabSet from '../../components/TabSet';
+
+
+const messages = defineMessages({
+  title: {
+    id: "hubs.core.config.title",
+    defaultMessage: "Hub settings",
+  },
+  general: {
+    id: "hubs.core.config.general",
+    defaultMessage: "General",
+  },
+  owners: {
+    id: "hubs.core.config.owners",
+    defaultMessage: "Owners",
+  },
+  members: {
+    id: "hubs.core.config.members",
+    defaultMessage: "Members",
+  },
+  chat: {
+    id: "hubs.core.config.chat",
+    defaultMessage: "Chat",
+  },
+  other: {
+    id: "hubs.core.config.other",
+    defaultMessage: "Other",
+  },
+  close: {
+    id: "hubs.core.config.close",
+    defaultMessage: "Close",
+  },
+  save_changes: {
+    id: "hubs.core.config.save_changes",
+    defaultMessage: "Save changes",
+  },
+});
+
+
+
+export default class HubConfigDialog extends React.Component {
+
+  render() {
+    const title = (
+      <FormattedMessage {...messages.title} />
+    );
+    const footer = (
+      <div className="d-flex justify-content-end w-100">
+        <button
+          type="button"
+          className="btn btn-secondary ml-3"
+          onClick={this.props.onCloseClicked}
+          >
+          <FormattedMessage {...messages.close} />
+        </button>
+        <button
+          type="button"
+          className="btn btn-primary ml-3"
+          onClick={this.props.onSaveClicked}
+          >
+          <FormattedMessage {...messages.save_changes} />
+        </button>
+      </div>
+    );
+
+    return (
+      <Modal
+        onCloseClicked={this.props.onCloseClicked}
+        isLarge={true}
+        title={title}
+        footer={footer}
+        cssClass="HubConfigDialog"
+        >
+        <TabSet
+          tabWrapperProps={{className: "row pt-0"}}
+          tabListClass="flex-md-column justify-content-center justify-content-md-start col-md-3 pt-2 pt-md-3 pb-md-4 pr-md-0 pl-md-2"
+          tabLinkClass="my-md-2"
+          tabContentClass="col-md-9 p-3 pb-4"
+          >
+          <GeneralPanel
+            hubConfig={this.props.hubConfig}
+            globalConfig={this.props.globalConfig}
+            tabTitle={<FormattedMessage {...messages.general} />}
+            handleChange={this.props.onConfigChange}
+            />
+          <UserPanel
+            users={this.props.users.owner}
+            globalConfig={this.props.globalConfig}
+            role="owner"
+            handleChange={this.props.onUserChange}
+            tabTitle={<FormattedMessage {...messages.owners} />}
+            urls={this.props.urls}
+            currentUser={this.props.currentUser}
+            />
+          <UserPanel
+            users={this.props.users.member}
+            globalConfig={this.props.globalConfig}
+            role="member"
+            handleChange={this.props.onUserChange}
+            tabTitle={<FormattedMessage {...messages.members} />}
+            urls={this.props.urls}
+            currentUser={this.props.currentUser}
+            />
+          <ChatPanel
+            hubConfig={this.props.hubConfig}
+            globalConfig={this.props.globalConfig}
+            tabTitle={<FormattedMessage {...messages.chat} />}
+            handleChange={this.props.onConfigChange}
+            />
+          <NotImplementedPanel
+            tabTitle={<FormattedMessage {...messages.other} />}
+            />
+        </TabSet>
+      </Modal>
+    );
+  }
+
+}
diff --git a/hubs/static/client/app/components/HubConfig/HubConfigPanelChat.js b/hubs/static/client/app/components/HubConfig/HubConfigPanelChat.js
new file mode 100644
index 0000000..f756e9d
--- /dev/null
+++ b/hubs/static/client/app/components/HubConfig/HubConfigPanelChat.js
@@ -0,0 +1,103 @@
+import React from 'react';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+
+
+const messages = defineMessages({
+  title: {
+    id: "hubs.core.config.chat.title",
+    defaultMessage: "Chat Settings",
+  },
+  intro_1: {
+    id: "hubs.core.config.chat.intro1",
+    defaultMessage: (
+      "If your team or project has an IRC channel associated with it, you "
+     +"can connect this hub to it via the Hubs chat widget."
+     ),
+  },
+  intro_2: {
+    id: "hubs.core.config.chat.intro2",
+    defaultMessage: "Please indicate your team's IRC channel below:",
+  },
+  channel_name: {
+    id: "hubs.core.config.chat.channel_name",
+    defaultMessage: "Channel name",
+  },
+  example: {
+    id: "hubs.core.config.chat.example",
+    defaultMessage: "Example:",
+  },
+  network: {
+    id: "hubs.core.config.chat.network",
+    defaultMessage: "IRC network",
+  },
+});
+
+
+export default class ChatPanel extends React.Component {
+
+  render() {
+    var networks = [],
+        channel = "#",
+        stillLoading = (
+          typeof this.props.hubConfig.chat_channel === "undefined"
+        );
+
+    if (this.props.hubConfig.chat_channel) {
+      channel = "#" + this.props.hubConfig.chat_channel.replace(/^#*/, "");
+    }
+
+    if (this.props.globalConfig.chat_networks) {
+      networks = this.props.globalConfig.chat_networks.map(
+        function(network, index) {
+          return (
+            <option value={network.domain} key={network.domain}>
+              {network.name} - {network.domain}
+            </option>
+          );
+        }.bind(this)
+      );
+    }
+
+    return (
+      <form onSubmit={(e) => {e.preventDefault();}}>
+        <FormattedMessage {...messages.title} tagName="h3" />
+        <FormattedMessage {...messages.intro_1} tagName="p" />
+        <FormattedMessage {...messages.intro_2} tagName="p" />
+        <div className="form-group">
+          <label htmlFor="hub-settings-chat-channel">
+            <FormattedMessage {...messages.channel_name} />
+          </label>
+          <input
+            type="text" className="form-control" name="chat_channel"
+            id="hub-settings-chat-channel"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={channel}
+            />
+          <p className="form-text text-muted">
+            <FormattedMessage {...messages.example} tagName="strong" />
+            <span className="ml-2">#fedora-devel</span>
+          </p>
+        </div>
+        <div className="form-group">
+          <label htmlFor="hub-settings-chat-domain">
+            <FormattedMessage {...messages.network} />
+          </label>
+          <select
+            name="chat_domain" className="form-control"
+            id="hub-settings-chat-domain"
+            disabled={stillLoading}
+            onChange={this.props.handleChange}
+            value={this.props.hubConfig.chat_domain || ""}
+            >
+            {networks}
+          </select>
+        </div>
+      </form>
+    );
+  }
+
+}
